SystemOrganization addCategory: #'tODE-Pharo-Core'!

TOSystem subclass: #TOPharoSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Pharo-Core'!

!TOPharoSystem class methodsFor: 'class initialization' stamp: 'dkh 6/3/2011 14:20'!
initialize
	"self initialize"
	
	self select! !

!TOPharoSystem methodsFor: 'expression evaluation' stamp: 'dkh 6/3/2011 14:31'!
evaluate: textOrStream in: aContext to: receiver notifying: aRequestor ifFail: failBlock

	^Compiler new evaluate: textOrStream in: aContext to: receiver notifying: aRequestor ifFail: failBlock! !

!TOSystem methodsFor: '*tode-pharo-core' stamp: 'dkh 7/19/2011 18:38'!
allMethodsWithSourceString: aString matchCase: caseSensitive
	^ SystemNavigation default allMethodsWithSourceString: aString matchCase: caseSensitive! !

!TOSystem methodsFor: '*tode-pharo-core' stamp: 'dkh 6/17/2011 10:23'!
methodReferenceClass

	^SourcedMethodReference! !

!TOObject methodsFor: '*tode-pharo-core' stamp: 'dkh 7/24/2011 10:07'!
deploy: aBlock
	aBlock value! !

!TOObject methodsFor: '*tode-pharo-core' stamp: 'dkh 8/9/2011 10:54'!
doit: aString pushResult: pushResult selecting: aTabSelector main: main
	| processResult semaphore process |
	semaphore := Semaphore new.
	process := [ 
	[ 
	processResult := [ 
	main currentSystem
		evaluate: aString
		in: nil
		to: self object
		notifying: self notifier
		ifFail: [ self error: 'evaluation failed' ] ]
		on: UndeclaredVariable , UnknownSelector
		do: [ :ex | 
			(ex isKindOf: UnknownSelector)
				ifTrue: [ ^ ex resume: ex name asSymbol ].
			self notify: 'Undeclared variable -->' at: ex interval first in: aString readStream.
			ex resume: nil ].
	pushResult
		ifTrue: [ self pushit: processResult selecting: aTabSelector main: main ] ]
		on: Error , Halt
		do: [ :ex | 
			main currentSession
				push:
					((TODoItException new)
						exception: ex;
						process: process;
						yourself)
				selecting: #debug.
			semaphore signal.
			Processor activeProcess suspend.
			ex isResumable
				ifTrue: [ ex resume ].
			processResult := 'Exception is not resumable: ' , ex description ].
	semaphore signal ] fork.
	semaphore wait.
	^ processResult! !

!TOObject methodsFor: '*tode-pharo-core' stamp: 'dkh 6/24/2011 13:00'!
notifier
	^ TOPharoCompilationRequestor new requestor: self! !

!TOObject methodsFor: '*tode-pharo-core' stamp: 'dkh 6/24/2011 12:57'!
notify: message at: location in: sourceStream
	"noop by default"

	! !

!TOObject methodsFor: '*tode-pharo-core' stamp: 'dkh 6/24/2011 12:56'!
selectFrom: first to: last
	"noop by default"

	! !

Object subclass: #TOPharoCompilationRequestor
	instanceVariableNames: 'requestor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Pharo-Core'!

!TOPharoCompilationRequestor methodsFor: 'accessing' stamp: 'dkh 6/24/2011 12:53'!
correctFrom: first to: last with: correctWord
	! !

!TOPharoCompilationRequestor methodsFor: 'accessing' stamp: 'dkh 6/24/2011 12:53'!
deselect
 ! !

!TOPharoCompilationRequestor methodsFor: 'accessing' stamp: 'dkh 6/24/2011 12:54'!
notify: message at: location in: sourceStream
	self requestor notify: message at: location in: sourceStream! !

!TOPharoCompilationRequestor methodsFor: 'accessing' stamp: 'dkh 6/24/2011 12:58'!
requestor
	^ requestor! !

!TOPharoCompilationRequestor methodsFor: 'accessing' stamp: 'dkh 6/24/2011 12:58'!
requestor: anObject
	requestor := anObject! !

!TOPharoCompilationRequestor methodsFor: 'accessing' stamp: 'dkh 6/24/2011 12:54'!
select! !

!TOPharoCompilationRequestor methodsFor: 'accessing' stamp: 'dkh 6/24/2011 12:54'!
selectFrom: first to: last
	requestor selectFrom: first to: last! !

!TOPharoCompilationRequestor methodsFor: 'accessing' stamp: 'dkh 6/24/2011 12:55'!
selectInvisiblyFrom: first to: last! !

!TOPharoCompilationRequestor methodsFor: 'accessing' stamp: 'dkh 6/24/2011 12:55'!
selectionInterval
    ^ 1 to: 1! !
TOPharoSystem initialize!
